// Definition of Queue class composed of List object
#ifndef QUEUE_C
#define QUEUE_C

#include "list.h"

template<class QUEUETYPE>
class Queue {
public:
   // no constructor; List constructor does initialization
   void enqueue( const QUEUETYPE & );
   int dequeue( QUEUETYPE & );
   int isQueueEmpty() const;
   void printQueue() const;
private:
   List<QUEUETYPE> q;
};

template<class QUEUETYPE>
void Queue<QUEUETYPE>::enqueue( const QUEUETYPE &value )
   { q.insertAtBack( value ); }

template<class QUEUETYPE>
int Queue<QUEUETYPE>::dequeue( QUEUETYPE &value )
   { return q.removeFromFront( value ); }

template<class QUEUETYPE>
int Queue<QUEUETYPE>::isQueueEmpty() const { return q.isEmpty(); }

template<class QUEUETYPE>
void Queue<QUEUETYPE>::printQueue() const { q.print(); }

#endif
